<?php
namespace Teknisa\CTB\Services;

use Teknisa\CTB\Services\Ctb00001RelatorioFaturamentoCustomizavelFactory;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;

class Ctb00001RelatorioFaturamentoCustomizavelService extends \Teknisa\CTB\Controllers\TeknisaCrud {

    protected $ctb00001RelatorioFaturamentoCustomizavelFactory;

    public function __construct($ctb00001RelatorioFaturamentoCustomizavelFactory, $entityManager) {
        $this->ctb00001RelatorioFaturamentoCustomizavelFactory = $ctb00001RelatorioFaturamentoCustomizavelFactory;
        $this->connection  = $entityManager->getConnection();
    }
    
    public function buscaDadosFaturamento($row) {
        $cdcontctbl = $this->montaSqlCdContContabil($row['CDCONTCTBL']);
        $cdtipooper = $this->montaSqlCdCdtipooper($row['CDTIPOOPER']);
        
        $cdempresa = $row['CDEMPRESA'];
        $dataini    = (string) date('d/m/Y', strtotime(str_replace('/', '-', $row['DATA_EMISSAO'][0])));
        $datafin    = (string) date('d/m/Y', strtotime(str_replace('/', '-', $row['DATA_EMISSAO'][1])));
        $dataSet = $this->ctb00001RelatorioFaturamentoCustomizavelFactory->buscaDadosFaturamento($cdcontctbl, $cdempresa, $cdtipooper, $datafin, $dataini); 
        return $dataSet;
    }

    private function montaSqlCdContContabil($cdcontctbl) {
        $sql = '(';
        if($cdcontctbl) {
            foreach($cdcontctbl as $value) {
                $value = (isset($value["P_CDCONTCTBL"])) ? $value["P_CDCONTCTBL"] : $value;
                $sql.= "'".$value."'".',';
            }
        }
        else throw new \Exception("Não foi encontrado nenhuma conta contábil.");
        $size = strlen($sql);
        return substr($sql,0, $size-1).')';
    }
    
    private function montaSqlCdCdtipooper($cdtipooper) {
        $sql = '(';
        if($cdtipooper) {
            foreach($cdtipooper as $value) {
                $value = (isset($value["P_CDTIPOOPER"])) ? $value["P_CDTIPOOPER"] : $value;
                $sql.= "'".$value."'".',';
            }
        }
        else throw new \Exception("Não foi encontrado nenhum tipo de operação.");
        $size = strlen($sql);
        return substr($sql,0, $size-1).')';
    }
    
    
    
}