<?php

namespace Teknisa\CTB\Services;

use Teknisa\CTB\Factories\Ger08000ContadorFactory;
use Teknisa\Libs\Util\Environment;

class Ger08000ContadorService {

    protected $entityManager;
    protected $environment;
    protected $nrorg;
    protected $factory;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager, Environment $environment, Ger08000ContadorFactory $factoryContador) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->nrorg = $environment->getNrorgTrab();
        $this->factory = $factoryContador;
    }

    public function verificaCdContador($row) {
        $existeContador = $this->factory->verificaCdContador(array(
            "CDCONTADOR2" => $row['CDCONTADOR2'],
            "NRORG" => $this->nrorg
        ));
        if ($existeContador !== false) {
            throw new \Exception("Já existe contador cadastrado com o código informado.");
        }
    }
}
