/* Tabela QFOMARPROD: Qualificao Marca Produto */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela QFOMARPROD */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Qualificao Marca Produto,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_SUP_QFOMARPROD
AFTER DELETE OR INSERT OR UPDATE
ON QFOMARPROD FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      V_DESC   := 'Produto '      || '' || NVL(:NEW.CDPRODUTO,'')   || ' ' ||
                  'Marca '        || '' || NVL(:NEW.CDMARCA,'')     || ' ' ||
                  'Aprov. Marca ' || '' || NVL(:NEW.IDAPRMARPRO,'') || ' ' ||
                  'Autorizacao '  || '' || NVL(:NEW.IDAUTMARPRO,'') || ' ' ||
                  'Dt.Val.Aprov ' || '' || NVL(:NEW.DTVALAPROVA,'') || ' ' ||
                  'Renda '        || '' || NVL(:NEW.VRRENDATU, '')  || ' ' ||
                  'Ident.Renda '  || '' || NVL(:NEW.IDRENMARPRO, '')|| ' ' ||
                  'Teste '        || '' || NVL(:NEW.NRTESTEPROD, '')|| ' ' ||
                  'Dt.Teste '     || '' || NVL(:NEW.DTTESTEQUA, '');
      V_ITPESQ := :NEW.CDPRODUTO||:NEW.CDMARCA;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   := 'Produto '      || '' || NVL(:NEW.CDPRODUTO,'')   || ' ' ||
                     'Marca '        || '' || NVL(:NEW.CDMARCA,'')     || ' ' ||
                     'Aprov. Marca ' || '' || NVL(:NEW.IDAPRMARPRO,'') || ' ' ||
                     'Autorizacao '  || '' || NVL(:NEW.IDAUTMARPRO,'') || ' ' ||
                     'Dt.Val.Aprov ' || '' || NVL(:NEW.DTVALAPROVA,'') || ' ' ||
                     'Renda '        || '' || NVL(:NEW.VRRENDATU, '')  || ' ' ||
                     'Ident.Renda '  || '' || NVL(:NEW.IDRENMARPRO, '')|| ' ' ||
                     'Teste '        || '' || NVL(:NEW.NRTESTEPROD, '')|| ' ' ||
                     'Dt.Teste '     || '' || NVL(:NEW.DTTESTEQUA, '');
         V_ITPESQ := :NEW.CDPRODUTO||:NEW.CDMARCA;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'Produto '      || '' || NVL(:OLD.CDPRODUTO,'')   || ' ' ||
                        'Marca '        || '' || NVL(:OLD.CDMARCA,'')     || ' ' ||
                        'Aprov. Marca ' || '' || NVL(:OLD.IDAPRMARPRO,'') || ' ' ||
                        'Autorizacao '  || '' || NVL(:OLD.IDAUTMARPRO,'') || ' ' ||
                        'Dt.Val.Aprov ' || '' || NVL(:OLD.DTVALAPROVA,'') || ' ' ||
                        'Renda '        || '' || NVL(:OLD.VRRENDATU, '')  || ' ' ||
                        'Ident.Renda '  || '' || NVL(:OLD.IDRENMARPRO, '')|| ' ' ||
                        'Teste '        || '' || NVL(:OLD.NRTESTEPROD, '')|| ' ' ||
                        'Dt.Teste '     || '' || NVL(:OLD.DTTESTEQUA, '');
            V_ITPESQ := :OLD.CDPRODUTO||:OLD.CDMARCA;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER)
   VALUES
      ('QFOMARPROD',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/

