var Ctb17000_Implantacao_Saldo_Controller = function(Ctb17000_Implantacao_Saldo_Service, General, ScreenService, templateManager, Messages_Contabil){

    this.edit = function(widget){
        General.edit(widget);
        this.setDadosSaldo(widget);
    };
    
    this.new = function(widget){
        widget.newRow();
        this.setDadosSaldo(widget);
    };

    this.setMask = function(widget){
         Ctb17000_Implantacao_Saldo_Service.getMask().then(function(success){
           var stMask = success.dataset.paramgeral[0].CDPICTCCTB;
            var mask = {
                "type": "fix",
                "params": {
                    "mask": stMask
                }
            };

            /* Atualiza a máscara da tela principal */
            widget.getField('NMCONTCTBLINI').fields[0].mask = mask;
            widget.getField('NMCONTCTBLFIN').fields[0].mask = mask;
            widget.getField('NMCONTCTBL').fields[0].mask = mask;
        });
     };

   this.ultimoDia = function(widget){
       var dtImpSaldo = widget.currentRow.DTSALDO;
        if (dtImpSaldo) {
            dtImpSaldo = moment(dtImpSaldo, "DD/MM/YYYY");
            dtImpSaldo = dtImpSaldo.endOf("month").format("DD/MM/YYYY");
            widget.currentRow.DTSALDO = dtImpSaldo;
        }
   };

   this.setSequencial = function (widget){
       Ctb17000_Implantacao_Saldo_Service.getSequencial().then(function (retorno) {
            var inSequencial = retorno.dataset.dataSetSequencial.NRSEQUENCIAL;
            widget.currentRow.NRIMPLSALDO = inSequencial;
            this.setDadosSaldo(widget);
        }.bind(this), function (error) {
            ScreenService.showMessage(error.data.error);
        });
   };

   this.setDadosSaldo = function(widget){
       widget.currentRow.CDEMPRESA = widget.appliedFilter.FILTER_ROW.CDEMPRESA;
       widget.currentRow.NMRAZSOCEMPR = widget.appliedFilter.FILTER_ROW.NMRAZSOCEMPR;
       widget.currentRow.DTSALDO = widget.appliedFilter.FILTER_ROW.DTSALDO;
       widget.currentRow.DTIMPSALDO = widget.currentRow.DTSALDO;
   };
   
    this.salvar = function(widget) {
        if (widget.isValid()) {
            widget.currentRow.__columns_to_return = widget.__columns_to_return;
            Ctb17000_Implantacao_Saldo_Service.salvar(widget.currentRow).then(function(retorno){
                ScreenService.showMessage(Messages_Contabil.CADASTRADO_COM_SUCESSO);
                widget.view();
                if(widget.currentRow.__is_new){
                    widget.currentRow.__is_new = false;
                    widget.currentRow.NRORG = retorno.dataset.columnsToReturn.NRORG;
                }
            }, function(error){
                if (error.data.error === 'JA_CADASTRADO'){
                    ScreenService.showMessage(Messages_Contabil.SALDO_JA_IMPLANTADO);
                } else{
                    ScreenService.showMessage(error.data.error);
                }
            });
        }
    };
};

Configuration(function(ContextRegister) {
     ContextRegister.register('Ctb17000_Implantacao_Saldo_Controller', Ctb17000_Implantacao_Saldo_Controller);
});